CREATE OR REPLACE FUNCTION FCT_CCUSTO_CONTRATO_REL
RETURN FCT_CCUSTO_CONTRATO_REL_TABLE PIPELINED
IS
    OUT_RECORD FCT_CCUSTO_CONTRATO_REL_TYPE := FCT_CCUSTO_CONTRATO_REL_TYPE (NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL,
																			 NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL,
																			 NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
	V_CALCULADO  VARCHAR2(1);
    V_IDTIPODESCIT       NUMBER;
	V_VRDESCONTOIT       NUMBER;
	V_PERCDESCONTOIT     NUMBER;
	V_VRTOTITEMCOMDESCIT NUMBER;
	V_IDTIPODESC        NUMBER;
	V_VRDESCONTO        NUMBER;
	V_PERCDESCONTO      NUMBER;
	V_VRTOTITEMCOMDESC  NUMBER;
	V_VRITEM    NUMBER;
	V_VRITEMRAT NUMBER;
    TYPE CCUSTO_CONTRATO_REL_REC IS RECORD (
		NRSEQCONTRATO      NUMBER,
		NRCONTRATOFCT      VARCHAR2(30),
		NRSEQMODCONTRA     NUMBER,
		NMMODCONTRATO      VARCHAR2(100),
		IDSITUACAOCONTRATO VARCHAR2(1),
		DTAPROVACAO       DATE,
		NRTIPOORCAMENTO    NUMBER,
		NMTIPOORCAMENTO    VARCHAR2(100),
		NRPARCNEGOCIO      NUMBER,
		NMPRINCIPALPARC    VARCHAR2(250),
		NMSECUNDARIPARC	   VARCHAR2(250),	   
		NRINSCRICAOPARC    VARCHAR2(20),
		CDOPERRESPONSAVEL  VARCHAR2(12),
		NMOPERADOR  VARCHAR2(250),
		NRORCAMENTO        VARCHAR2(30),
		NMORCAMENTOMODELO  VARCHAR2(250),
		DTACEITEORCA       DATE,
		NMITEMCONTRATO     VARCHAR2(250),
		CDSERVORCA         NUMBER,
		NMSERVORCA         VARCHAR2(250),
		QTMEDIDACALCULADA  NUMBER,
		CDTPMEDIDAVARIAVEL NUMBER,
        DSTPMEDIDAVARIAVEL VARCHAR2(250),
		VRTOTITEMCONT      NUMBER,
		IDATIVO            VARCHAR2(1),
		CDCENTCUST         VARCHAR2(4),
        NMCENTCUST         VARCHAR2(100),
		PERCCENTCUSTCONTR  NUMBER,
		VRCENTCUSTITEM     NUMBER
    );
    TYPE CCUSTO_CONTRATO_REC_TAB IS TABLE OF CCUSTO_CONTRATO_REL_REC INDEX BY BINARY_INTEGER;
    V_CCUSTO_CONTRATO CCUSTO_CONTRATO_REC_TAB;
BEGIN
    FOR C_CONTRATOS IN (SELECT CONT.NRSEQCONTRATO, CONT.NRCONTRATOFCT, CONT.NRSEQMODCONTRA, MODC.NMMODCONTRATO, CONT.IDSITUACAOCONTRATO,
							   APRV.DTAPROVCONTR AS DTAPROVACAO, CONT.NRTIPOORCAMENTO, TPORCA.NMTIPOORCAMENTO, CONT.NRPARCNEGOCIO, PARC.NMPRINCIPALPARC, 
							   PARC.NMSECUNDARIPARC,PARC.NRINSCRICAOPARC, CONT.CDOPERRESPONSAVEL, OPER.NMOPERADOR, ORCA.NRORCAMENTO, 
							   ORCMOD.NMORCAMENTOMODELO, ORCA.DTACEITEORCA,  ITCONT.NRITEMOCONTRATO, ITCONT.NMITEMCONTRATO, ITCONT.CDSERVORCA, SERV.NMSERVORCA,
							   ITCONT.QTMEDIDACALCULADA, ITCONT.CDTPMEDIDAVARIAVEL, TPMED.DSTPMEDIDASERV AS DSTPMEDIDAVARIAVEL,ITCONT.VRTOTITEMCONT, CONT.IDATIVO 
				          FROM FCT_CONTRATO CONT
					      JOIN FCT_MODELOCONTRATO MODC
						    ON MODC.NRSEQMODCONTRA = CONT.NRSEQMODCONTRA
					      LEFT JOIN FCT_APROVACONTRATO APRV 
						   ON APRV.NRSEQCONTRATO = CONT.NRSEQCONTRATO
					     JOIN FCT_TIPOORCAMENTO TPORCA
						   ON CONT.NRTIPOORCAMENTO = TPORCA.NRTIPOORCAMENTO
					     JOIN PARCNEGOCIO PARC
						   ON PARC.NRPARCNEGOCIO = CONT.NRPARCNEGOCIO
					     JOIN OPERADOR OPER
						   ON OPER.CDOPERADOR = CONT.CDOPERRESPONSAVEL
					     JOIN FCT_REFEORCACONT REFEOC
						   ON REFEOC.NRSEQCONTRATO = CONT.NRSEQCONTRATO
					     JOIN FCT_ORCAMENTO ORCA
						   ON ORCA.NRSEQORCAMENTO = REFEOC.NRSEQORCAMENTO
					     JOIN FCT_ORCAMENTOMODELO ORCMOD
						   ON ORCMOD.NRORCAMENTOMODELO = ORCA.NRORCAMENTOMODELO
					     JOIN FCT_ITEMCONTRATO ITCONT
						   ON ITCONT.NRSEQCONTRATO = CONT.NRSEQCONTRATO
						  AND ITCONT.NRITEMCONTRATOPAI IS NOT NULL
					     JOIN FCT_SERVICOORCA SERV
						   ON SERV.CDSERVORCA = ITCONT.CDSERVORCA
						 JOIN FCT_TIPOMEDIDASERV TPMED
						   ON TPMED.CDTPMEDIDASERV = ITCONT.CDTPMEDIDAVARIAVEL) LOOP
		/* LOOP POR CENTRO DE CUSTO*/
		FOR C_CENTCUST IN (SELECT RELAC.CDCENTCUST, CC.NMCENTCUST, RELAC.VRPERCENTUALCONTCCUST
						 	 FROM FCT_RELACCONTRCENTCUST RELAC
							 JOIN CENTCUST CC
							   ON CC.CDCENTCUST = RELAC.CDCENTCUST
							WHERE NRSEQCONTRATO = C_CONTRATOS.NRSEQCONTRATO) LOOP
			V_CALCULADO := 'N';
			/* Verifica se tem desconto na negociao de valores ou item da negocicao de valores */
				BEGIN
					SELECT IDTPDESCONTO , VRDESCITEM, VRPERCDESCITEM, VRTOTITEMCOMDESC
					  INTO V_IDTIPODESC, V_VRDESCONTO, V_PERCDESCONTO,  V_VRTOTITEMCOMDESCIT
					  FROM FCT_ITNEGOCIACAOCONTRATO 
					 WHERE NRITEMOCONTRATO = C_CONTRATOS.NRITEMOCONTRATO
					   AND NRPARCFATURA = C_CONTRATOS.NRPARCNEGOCIO
					   AND CDSERVORCA = C_CONTRATOS.CDSERVORCA;
				EXCEPTION
					WHEN NO_DATA_FOUND THEN BEGIN
						V_IDTIPODESCIT       := NULL;
						V_VRDESCONTOIT       := NULL;
						V_PERCDESCONTOIT     := NULL;
						V_VRTOTITEMCOMDESCIT := NULL;
					END;
				END;
				IF ((V_VRDESCONTOIT = 0) OR (V_VRDESCONTOIT IS NULL)) THEN
					BEGIN
						SELECT DISTINCT NEG.IDTPDESCONTO, NEG.VRDESCITEM, NEG.VRPERCDESCITEM, NEG.VRTOTITEMCOMDESC   
						  INTO V_IDTIPODESC, V_VRDESCONTO, V_PERCDESCONTO, V_VRTOTITEMCOMDESC
						  FROM FCT_NEGOCIACAOCONTRATO NEG
						  JOIN FCT_ITNEGOCIACAOCONTRATO ITNEG
							ON ITNEG.NRNEGOCIACAOCONTRATO = NEG.NRNEGOCIACAOCONTRATO
						   AND ITNEG.NRORG = NEG.NRORG
						 WHERE NEG.NRSEQCONTRATO = C_CONTRATOS.NRSEQCONTRATO
						   AND ITNEG.CDSERVORCA = C_CONTRATOS.CDSERVORCA;	   
					EXCEPTION
						WHEN NO_DATA_FOUND THEN BEGIN
							V_IDTIPODESC   := NULL;
							V_VRDESCONTO   := NULL;
							V_PERCDESCONTO := NULL;
							V_VRTOTITEMCOMDESC := NULL;
						END;
					END;
					IF ((V_PERCDESCONTO > 0) AND (V_PERCDESCONTO IS NOT NULL)) THEN
					/* Calcula o valor do rateio utilizando o desconto do contrato*/
						V_VRITEM := C_CONTRATOS.VRTOTITEMCONT - ((C_CONTRATOS.VRTOTITEMCONT*V_PERCDESCONTO)/100);
						V_VRITEMRAT := (V_VRITEM*C_CENTCUST.VRPERCENTUALCONTCCUST)/100;
						V_CALCULADO:= 'S';
					END IF;
				ELSE
					V_IDTIPODESC   := NULL;
					V_VRDESCONTO   := NULL;
					V_PERCDESCONTO := NULL;
					V_VRTOTITEMCOMDESC := NULL;
					/* Calcula o valor do rateio utilizando o desconto do item*/
					V_VRITEM := V_VRTOTITEMCOMDESCIT;
					V_VRITEMRAT := (V_VRTOTITEMCOMDESCIT*C_CENTCUST.VRPERCENTUALCONTCCUST)/100;
					V_CALCULADO:= 'S';
				END IF;
				IF (V_CALCULADO = 'N') THEN
					V_VRITEM := C_CONTRATOS.VRTOTITEMCONT;
					V_VRITEMRAT := (C_CONTRATOS.VRTOTITEMCONT*C_CENTCUST.VRPERCENTUALCONTCCUST)/100;
					V_CALCULADO:= 'S';
				END IF;
			/* Grava os dados */
                OUT_RECORD.NRSEQCONTRATO :=  C_CONTRATOS.NRSEQCONTRATO;
				OUT_RECORD.NRCONTRATOFCT := C_CONTRATOS.NRCONTRATOFCT;
				OUT_RECORD.NRSEQMODCONTRA := C_CONTRATOS.NRSEQMODCONTRA;
				OUT_RECORD.NMMODCONTRATO := C_CONTRATOS.NMMODCONTRATO;
				OUT_RECORD.IDSITUACAOCONTRATO := C_CONTRATOS.IDSITUACAOCONTRATO;
				OUT_RECORD.DTAPROVACAO := C_CONTRATOS.DTAPROVACAO;
				OUT_RECORD.NRTIPOORCAMENTO := C_CONTRATOS.NRTIPOORCAMENTO;
				OUT_RECORD.NMTIPOORCAMENTO := C_CONTRATOS.NMTIPOORCAMENTO;
				OUT_RECORD.NRPARCNEGOCIO := C_CONTRATOS.NRPARCNEGOCIO;
				OUT_RECORD.NMPRINCIPALPARC := C_CONTRATOS.NMPRINCIPALPARC;
				OUT_RECORD.NMSECUNDARIPARC := C_CONTRATOS.NMSECUNDARIPARC;						   
				OUT_RECORD.NRINSCRICAOPARC := C_CONTRATOS.NRINSCRICAOPARC;
				OUT_RECORD.CDOPERRESPONSAVEL := C_CONTRATOS.CDOPERRESPONSAVEL;
				OUT_RECORD.NMOPERADOR := C_CONTRATOS.NMOPERADOR;
				OUT_RECORD.NRORCAMENTO := C_CONTRATOS.NRORCAMENTO;
				OUT_RECORD.NMORCAMENTOMODELO := C_CONTRATOS.NMORCAMENTOMODELO;
				OUT_RECORD.DTACEITEORCA := C_CONTRATOS.DTACEITEORCA;
				OUT_RECORD.NMITEMCONTRATO := C_CONTRATOS.NMITEMCONTRATO;
				OUT_RECORD.CDSERVORCA := C_CONTRATOS.CDSERVORCA;
				OUT_RECORD.NMSERVORCA := C_CONTRATOS.NMSERVORCA;
				OUT_RECORD.CDTPMEDIDAVARIAVEL := C_CONTRATOS.CDTPMEDIDAVARIAVEL;
                OUT_RECORD.DSTPMEDIDAVARIAVEL := C_CONTRATOS.DSTPMEDIDAVARIAVEL;
				OUT_RECORD.QTMEDIDACALCULADA := C_CONTRATOS.QTMEDIDACALCULADA;
				OUT_RECORD.VRTOTITEMCONT := V_VRITEM;
				OUT_RECORD.IDATIVO :=  C_CONTRATOS.IDATIVO;
				OUT_RECORD.CDCENTCUST :=  C_CENTCUST.CDCENTCUST;
				OUT_RECORD.NMCENTCUST := C_CENTCUST.NMCENTCUST;
				OUT_RECORD.PERCCENTCUSTCONTR := C_CENTCUST.VRPERCENTUALCONTCCUST;
				OUT_RECORD.VRCENTCUSTITEM := V_VRITEMRAT;
                PIPE ROW (OUT_RECORD);
		END LOOP; -- C_CENTCUST	
    END LOOP; --C_CONTRATOS
END;