function ImageStaticController($scope, ScreenService) {
	function formatValue(value) {
	  // Se o valor for um número, adiciona 'px' como sufixo
	  if (typeof value === 'number') {
	    return value + 'px';
	  }
	
	  // Se o valor for uma string
	  if (typeof value === 'string') {
	    // Verifica se a string já possui um sufixo (usando uma expressão regular)
	    var hasSuffix = /[a-zA-Z%]+$/.test(value);
	
	    // Se não tiver sufixo, adiciona 'px'
	    if (!hasSuffix) {
	      return value + 'px';
	    }
	
	    // Se já tiver sufixo, retorna a string original
	    return value;
	  }
	
	  // Caso o valor não seja número nem string, retorna '0px' como fallback
	  return '0px';
	}

	$scope.getImageStyle = function() {
		var result = [];
		if ($scope.field.height !== undefined) result.push('height: ' + formatValue($scope.field.height));
		if ($scope.field.width !== undefined) result.push('width: ' + formatValue($scope.field.width));
		if ($scope.field.objectFit !== undefined) result.push('object-fit: ' + ($scope.field.objectFit || 'unset'));
		if (result.length) result.push('');
		return result.join('; ');  
	};
}
